#include "sprite.h"
#include "window.h"
extern "C"
{
#include "font.h"
#include "fxlib.h"
#include "MonochromeLib.h"
#include "usefull.h"
#include "string.h"
}


void afficheFenetre(int wich)
{
switch(wich)
    {
    case 1:fenetre(0,43,128,64);break;
    case 2:fenetre(39,43,128,64);break;
    case 4:fenetre(0,0,75,64);break;
    case 5:fenetre(0,0,128,64);break;
    case 6:
        if(getFenetre(0)<4)fenetre(0,26,56,48);
        else if(getFenetre(0)==4)fenetre(0,26,56,47);
        else if(getFenetre(0)==5)fenetre(0,26,56,46);
        else fenetre(0,26,56,44);
        break;
    case 7:fenetre(0,0,64,64);break;
    case 8:fenetre(64,0,128,64);break;
    case 9:fenetre(0,0,128,43);break;
    case 10:fenetre(82,30,128,64);break;
    case 11:fenetre(0,0,128,22);break;
    case 12:fenetre(0,22,128,64);break;
    case 17:fenetre(64,0,128,64);break;
    }
}



void dialogueMenuDepart(char* dialogue)
{
int longeur;
for(int d = 72,a = 0,b=8;dialogue[a]!=0;a++,d+=4)
    {
    if(dialogue[a]==32)//si on rencontre un espace
        {
        longeur = 4;
        for(int c=(a+1);dialogue[c]!=' ' && dialogue[c]!=0;c++,longeur+=4);//on regarde la taille du mot
            if((longeur+d)>120)//si ca depasse la taille de la fenetre
            {
            b+=6;
            d=72;
            a++;
            }
        }
    PrintCharXY(d,b,dialogue[a]);//on affiche le caracter dans une police 3*5
    }
}


void erreur(char* dire,int erreur)
{
unsigned int key;
ML_clear_vram();
char dialogue[500]={0};
strcat(dialogue,"erreur, ");
strcat(dialogue,dire);
strcat(dialogue,". priere de contacter dodormeur (le createur de ce jeu) a damien.1997[at]hotmail.com   code d'erreur : ");


int i, length=0;
char str[12] = "0";
if(erreur<0)
    {
    length++;
    str[0] = '-';
    erreur = -erreur;
    }
for(i=erreur ; i ; i/=10) length++;
str[length] = 0;
for( ; erreur ; erreur/=10) str[--length] = erreur%10+'0';
strcat(dialogue,str);


int longeur;
for(int d = 0,a = 0,b=0;dialogue[a]!=0;a++,d+=4)
    {
    if(dialogue[a]==32)//si on rencontre un espace
        {
        longeur = 4;
        for(int c=(a+1);dialogue[c]!=' ' && dialogue[c]!=0;c++,longeur+=4);//on regarde la taille du mot
            if((longeur+d)>120)//si ca depasse la taille de la fenetre
            {
            b+=6;
            d=0;
            a++;
            }
        }
    PrintCharXY(d,b,dialogue[a]);//on affiche le caracter dans une police 3*5
    ML_display_vram();
    Sleep(40);
    }
while(1)GetKey(&key);
}

bool fenetreChoix()
{
bool choix=1;
unsigned char fleche[] = {0xC0, 0xE0, 0xF0, 0xE0, 0xC0};
while(key_down(K_EXE))Sleep(2);
while(!key_down(K_EXE))
    {
    fenetre(97,20,128,43);
    PrintStr(110,26,"oui");
    PrintStr(110,32,"non");
    ML_bmp_or(fleche,104,32-6*choix,5,5);
    if(key_down(K_UP) || key_down(K_DOWN)){choix = 1-choix;
    while(key_down(K_UP) || key_down(K_DOWN))Sleep(5);}
    ML_display_vram();
    Sleep(20);
    }
return choix;
}

void fenetre(int x1,int y1,int x2, int y2)
{
unsigned char haut_gauche[] = {0x30, 0x5A, 0xFC, 0x84, 0x4A, 0x34, 0x28};
unsigned char haut_droite[] = {0x18, 0xAC, 0x7E, 0x42, 0xA4, 0x58, 0x28};
unsigned char bas_gauche[] = {0x28, 0x34, 0x5A, 0xFC, 0x84, 0x4A, 0x30};
unsigned char bas_droite[] = {0x28, 0x58, 0xAC, 0x7E, 0x42, 0xA4, 0x18};
int fenetre = getFenetre(0);
ML_rectangle(x1,y1,x2-1,y2-1,0,ML_WHITE,ML_WHITE);

if(fenetre<4)
    {
    ML_bmp_or(haut_gauche,x1,y1,7,7);
    ML_bmp_or(bas_gauche,x1,y2-7,7,7);
    ML_bmp_or(haut_droite,x2-7,y1,7,7);
    ML_bmp_or(bas_droite,x2-7,y2-7,7,7);

    ML_line(x1+1,y1+7,x1+1,y2-8,ML_BLACK);
    ML_line(x1+3,y1+7,x1+3,y2-8,ML_BLACK);
    ML_line(x2-3,y1+7,x2-3,y2-7,ML_BLACK);
    ML_line(x2-5,y1+7,x2-5,y2-7,ML_BLACK);

    ML_line(x1+7,y1+1,x2-7,y1+1,ML_BLACK);

    if(fenetre == 1)ML_rectangle(x1+7,y1+3,x2-8,y1+4,0,ML_BLACK,ML_BLACK);
    else ML_line(x1+7,y1+3,x2-8,y1+3,ML_BLACK);

    ML_line(x1+7,y2-4,x2-8,y2-4,ML_BLACK);
    if(fenetre < 3)ML_rectangle(x1+7,y2-1,x2-8,y2-2,0,ML_BLACK,ML_BLACK);
    else ML_rectangle(x1+7,y2-2,x2-8,y2-2,0,ML_BLACK,ML_BLACK);
    }
if(fenetre == 4)
    {
    ML_rectangle(x1,y1,x2-1,y2-1,2,ML_BLACK,ML_WHITE);
    ML_rectangle(x1+3,y1+3,x2-4,y2-4,1,ML_BLACK,ML_WHITE);
    }
if(fenetre == 5)
    {
    ML_rectangle(x1,y1,x2-1,y2-1,1,ML_BLACK,ML_WHITE);
    ML_rectangle(x1+1,y1+1,x2-2,y2-2,1,ML_CHECKER,ML_WHITE);
    ML_rectangle(x1+2,y1+2,x2-3,y2-3,1,ML_BLACK,ML_WHITE);
    }
if(fenetre == 6)
    {
    ML_rectangle(x1,y1,x2-1,y2-1,1,ML_BLACK,ML_WHITE);
    }
}



void dialogueAnimation(char* temp)
{
static char texte[200];
static int a=0;
int b;
if(temp[0])
    {
    for(b=0;temp[b]!=0;b++)texte[b]=temp[b];
    texte[b]=temp[b];
    a=0;
    while(texte[a]!=0)a++;
    texte[a]=1;
    dialogue(texte);
    }
else
    {
    texte[a]=2;
    dialogue(texte);
    }

}



void aide()
{
dialogue("bienvenue dans l'aide !");
}


void dialogue(char* dialogue)
{
unsigned char fleche[] = {0xF8, 0xF8, 0x70, 0x20};
int longeur;
int a = 0;
int frame =40;//pour le clignotement de la fleche
int lent = 0;
if(getFastGameEnnemi(0))return ;
while(dialogue[a]>2)a++;
if(dialogue[a]!=2)lent = 1;
a=0;
afficheFenetre(1);//affiche la fenetre
for(int d = 8,b=48;dialogue[a]!=0 && dialogue[a]!=1 && dialogue[a]!=2;a++,d+=4)
    {
    if(dialogue[a]==32)//si on rencontre un espace
        {
        longeur = 4;
        for(int c=(a+1);dialogue[c]!=' ' && dialogue[c]>2;c++,longeur+=4);//on regarde la taille du mot
            if((longeur+d)>120)//si ca depasse la taille de la fenetre
            {
            if(b == 48)//retour a la ligne
                {
                b+=6;
                d=8;
                a++;
                }
            else // ou reaffichage de fenetre
                {
                if(lent)
                    {
                    while(!key_down(K_EXE))
                        {
                        if(frame%80>40)ML_bmp_or(fleche,116,55,5,4);
                        else ML_rectangle(116,55,120,59,0,ML_WHITE,ML_WHITE);
                        ML_display_vram();
                        Sleep(15);
                        frame++;
                        }
                    while(key_down(K_EXE))
                        {
                        if(frame%80>40)ML_bmp_or(fleche,116,55,5,4);
                        else ML_rectangle(116,55,120,59,0,ML_WHITE,ML_WHITE);
                        ML_display_vram();
                        Sleep(15);
                        frame++;
                        }
                    }
                frame = 40;
                afficheFenetre(1);
                d=8;
                b-=6;
                a++;
                }
            }
        }
    PrintCharXY(d,b,dialogue[a]);//on affiche le caracter dans une police 3*5
    if(lent)ML_display_vram();
    if(lent)Sleep(80-20*getVitesseDialogue(0)-20*key_down(K_EXE));
    }
frame=0;
if(dialogue[a] == 0)while(key_down(K_EXE) && frame<5000)frame++;
if(dialogue[a] == 0)while(!key_down(K_EXE));
}
