#ifndef BOMBERMAN_H
#define BOMBERMAN_H
#define BAS 0
#define HAUT 1
#define GAUCHE 2
#define DROITE 3

class Bomberman
{
    public:

        Bomberman();
        void input();
        void afficher();
        bool mort();
        void nouveauChapitre();
        void nouveauNiveau();
        void nouveauNiveauRandom();
        void perdu();

    private:

        unsigned char l_sprites[4][3][30];
        unsigned char d_sprites[4][3][30];

        unsigned char masque[4][3][30];

        unsigned char l_bombes[3][24];
        unsigned char d_bombes[3][24];

        int bombesX[8];
        int bombesY[8];
        unsigned char bombesTemp[8];
        char direction;
        char animation;
        char directionAnimation;
        int X,Y;
        bool appuyer;
        int puissance;
        int nombreBombe;
        bool percant;
        int vitesse;
        int vie;
        int vieMax;
        int invicibilite;
};

#endif // BOMBERMAN_H
